﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ConsoleApp3.WebServiceGalileo;

namespace ConsoleApp3
{
    class MyWebServiceApp
    {
        #region Private Member Variables
        PNRBFRetrieveMods pnrbfRetrieveMods;
        PNRAddr pnrAddr;
        object[] pnrAddrArray;
        FareRedisplayMods fareRedisplayMods;
        DisplayAction disp;
        FareNumInfo fareNumInfo;
        Header header;
        string recLoc;
        string userName;
        string password;
        //string[]                fareNumArray;
        PNRBFManagement_10 pnrbfManagement_10_Request;
        List<Object> pnrElementList;
        List<ItemsChoiceType23> pnrTypeList;
        EndTransactionMods endTransactionMods;
        EndTransactRequest endTransactRequest;
        input1 input;
        BookingPortType port;
        output1 output;
        private string StateInfo;
        #endregion

        public MyWebServiceApp(string RecLoc)
        {
            this.recLoc   = RecLoc;
            this.userName = "user1";
            this.password = "user1";
        }

        private void Initialize()
        {
            this.pnrbfRetrieveMods = new PNRBFRetrieveMods();
            this.pnrAddr = new PNRAddr();
            this.fareRedisplayMods = new FareRedisplayMods();
            this.disp = new DisplayAction();
            this.fareNumInfo = new FareNumInfo();

            this.fareRedisplayMods.DisplayAction = this.disp;

            //Set Header
            this.header = new Header();
            this.header.UserName = this.userName;
            this.header.Password = this.password;

            //pnrAddr
            this.pnrAddr.RecLoc = this.recLoc;
            this.pnrAddrArray = new object[1];
            this.pnrAddrArray[0] = this.pnrAddr;
            this.pnrbfRetrieveMods.Items = this.pnrAddrArray;

            this.pnrbfManagement_10_Request = new PNRBFManagement_10();
            this.pnrElementList = new List<object>();
            this.pnrTypeList = new List<ItemsChoiceType23>();

            this.pnrElementList.Add(this.pnrbfRetrieveMods);
            this.pnrElementList.Add(this.fareRedisplayMods);

            this.pnrTypeList.Add(ItemsChoiceType23.PNRBFRetrieveMods);
            this.pnrTypeList.Add(ItemsChoiceType23.FareRedisplayMods);

            this.pnrbfManagement_10_Request.ItemsElementName = pnrTypeList.ToArray();
            this.pnrbfManagement_10_Request.Items = pnrElementList.ToArray();

            this.endTransactRequest = new EndTransactRequest();
            this.endTransactionMods = new EndTransactionMods();
            this.endTransactionMods.EndTransactRequest = this.endTransactRequest;

            this.pnrElementList.Add(this.endTransactionMods);
            this.pnrTypeList.Add(ItemsChoiceType23.EndTransactionMods);

            this.input = new input1(this.header, this.pnrbfManagement_10_Request);
            this.port = new BookingPortTypeClient();
        }

        private void SetOutputItin()
        {
            try
            {
                this.disp.Action = "I";
                this.output = port.execute(this.input);

                string state = this.GetOutputState(output);
                StateInfo = state;

                if (state.Length > 0)
                {
                    if (state != "D0002308")
                    {
                        System.Console.WriteLine("FARE EXISTS");
                    }
                    else
                        System.Console.WriteLine("NO FARES");
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        private string GetOutputState(output1 output)
        {
            string state = "";

            if (output.PNRBFManagement_10.Items != null && output.PNRBFManagement_10.Items.Count() > 0)
            {
                for (int x = 0; x <= output.PNRBFManagement_10.Items.Count() - 1; x++)
                {
                    if (output.PNRBFManagement_10.Items[x] is PNRBFRetrieve)
                    {
                        PNRBFRetrieve pnr = (PNRBFRetrieve)output.PNRBFManagement_10.Items[x];
                        if (pnr != null && pnr.Items.Count() > 0)
                        {
                            for (int countPNR = 0; countPNR <= pnr.Items.Count() - 1; countPNR++)
                            {
                                if (pnr.Items[countPNR] is ErrText)
                                {
                                    ErrText errText = (ErrText)(pnr.Items[countPNR]);
                                    state = errText.Err;
                                }
                            }
                        }
                    }


                    if (state.Length == 0 && output.PNRBFManagement_10.Items[x] is DocProdDisplayStoredQuote)
                    {
                        DocProdDisplayStoredQuote doc = (DocProdDisplayStoredQuote)output.PNRBFManagement_10.Items[x];
                        if (doc != null && doc.Items.Count() > 0)
                        {
                            for (int countDoc = 0; countDoc <= doc.Items.Count() - 1; countDoc++)
                            {
                                if (doc.Items[countDoc] is ErrText)
                                {
                                    ErrText errText = (ErrText)doc.Items[countDoc];
                                    state = errText.Err;
                                }
                            }
                        }
                    }
                }
            }
            return state;
        }

        static void Main(string[] args)
        {
            MyWebServiceApp app = new MyWebServiceApp("NW9PNM");
            app.Initialize();
            app.SetOutputItin();
        }
    }
}
